'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.signAction = exports.verifyAction = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     this is used like: new Ed25519([privateKey])
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     it has the shape:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     // identity.sign = (action) => signature: string
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     // identity.verify = (action, signature, pubKey) => valid: bool
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     // identity.publicKey = () => hex: string
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     // identity.privateKey = () => hex: string
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     */

var _utils = require('./utils');

Object.defineProperty(exports, 'verifyAction', {
  enumerable: true,
  get: function get() {
    return _utils.verifyAction;
  }
});
Object.defineProperty(exports, 'signAction', {
  enumerable: true,
  get: function get() {
    return _utils.signAction;
  }
});

var _elliptic = require('elliptic');

var _elliptic2 = _interopRequireDefault(_elliptic);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function toHex(arr) {
  return _elliptic2.default.utils.toHex(arr).toUpperCase();
}

function fromHex(hex) {
  return _elliptic2.default.utils.toArray(hex, 'hex');
}

// Store EdDSA context statically
var ecContext = void 0;

var Ed25519 = function () {
  function Ed25519(privateKey) {
    _classCallCheck(this, Ed25519);

    // Initialize EdDSA context if not already initialized
    ecContext = ecContext || new _elliptic.eddsa('ed25519');

    if (privateKey) {
      this.key = ecContext.keyFromSecret(fromHex(privateKey));
    } else {
      this.key = this.generateKey();
    }
  }

  _createClass(Ed25519, [{
    key: 'generateKey',
    value: function generateKey() {
      var secret = void 0;

      if ((typeof window === 'undefined' ? 'undefined' : _typeof(window)) === 'object' && window.crypto && window.crypto.getRandomValues) {
        secret = new Uint8Array(256);
        window.crypto.getRandomValues(secret);
      } else {
        console.warn('Warning: Using insecure methods to generate private key');
        secret = [];
        for (var i = 0; i < 256; i++) {
          secret.push(Math.random() * 9007199254740991); // aka Number.MAX_SAFE_INTEGER
        }
      }

      return ecContext.keyFromSecret(secret);
    }

    // verify with no private key

  }, {
    key: 'verifyPublic',
    value: function verifyPublic(message, signature, publicKey) {
      // Import public key
      var key = ecContext.keyFromPublic(publicKey, 'hex');

      // Verify signature
      // 7~10ms on my machine
      return key.verify((0, _utils.codifyMessage)(message), signature);
    }

    // verify message against our own private key

  }, {
    key: 'verify',
    value: function verify(message, signature) {
      // Verify signature
      this.key.verify(message, signature);
    }

    // signs a message with our private key

  }, {
    key: 'sign',
    value: function sign(message) {
      // return signature
      if (this.key) {
        // ~1ms on my machine
        return this.key.sign((0, _utils.codifyMessage)(message)).toHex();
      }

      return null;
    }
  }, {
    key: 'privateKey',
    get: function get() {
      if (this.key) {
        return toHex(this.key.getSecret());
      }
      return; // undefined
    }
  }, {
    key: 'publicKey',
    get: function get() {
      if (this.key) {
        return toHex(this.key.getPublic());
      }
      return; // undefined
    }
  }]);

  return Ed25519;
}();

exports.default = Ed25519;