'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.encodeAction = encodeAction;
exports.verifyAction = verifyAction;
exports.signAction = signAction;
exports.codifyMessage = codifyMessage;

var _jsonStableStringify = require('json-stable-stringify');

var _jsonStableStringify2 = _interopRequireDefault(_jsonStableStringify);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function encodeAction(action) {
  var cleanAction = action;

  if (action && action.meta) {
    var _extends2;

    // if meta keys might be set, remove them.
    cleanAction = _extends({}, action, {
      meta: _extends((_extends2 = {}, _defineProperty(_extends2, _constants.META_PUBLIC_KEY, undefined), _defineProperty(_extends2, _constants.META_SIGNATURE, undefined), _extends2), action.meta)
    });
  }

  return (0, _jsonStableStringify2.default)(cleanAction);
}

function omitActionSignature(action) {
  var _extends3;

  return _extends({}, action, {
    meta: _extends({}, action.meta, (_extends3 = {}, _defineProperty(_extends3, _constants.META_PUBLIC_KEY, undefined), _defineProperty(_extends3, _constants.META_SIGNATURE, undefined), _extends3))
  });
}

// calls back with true or false, whether the action is valid
function verifyAction(identity, callback, action) {
  var publicKey = action && action.meta && action.meta[_constants.META_PUBLIC_KEY],
      signature = action && action.meta && action.meta[_constants.META_SIGNATURE];

  callback(identity.verifyPublic(encodeAction(omitActionSignature(signAction)), signature, publicKey));
}

// calls back with the action plus signature metadata
function signAction(identity, callback, action) {
  var _extends4;

  callback(_extends({}, action, {
    meta: _extends({}, action.meta, (_extends4 = {}, _defineProperty(_extends4, _constants.META_PUBLIC_KEY, identity.publicKey), _defineProperty(_extends4, _constants.META_SIGNATURE, identity.sign(encodeAction(action))), _extends4))
  }));
}

// Sign message (must be an array, or it'll be treated as a hex sequence)
function codifyMessage(message) {
  message.split('').map(function (m) {
    return m.charCodeAt(0);
  });
}